/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.models.documentos;

import danielcortes.xyz.data.ConnectionHolder;
import danielcortes.xyz.data.SQLiteConnectionHolder;
import danielcortes.xyz.models.caja.Caja;
import danielcortes.xyz.models.caja.CajaDAO;
import danielcortes.xyz.models.caja.SQLiteCajaDAO;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class SQLiteDocumentosDAO extends DocumentosDAO {
    public SQLiteDocumentosDAO() {
        this.connectionHolder = new SQLiteConnectionHolder();
    }

    @Override
    public List<Documentos> findAll() {
        List<Documentos> documentosList = new ArrayList<>();
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from documentos");
            ResultSet rs = ps.executeQuery();

            documentosList = this.documentosFromResultSet(rs);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return documentosList;
    }

    @Override
    public Documentos findById(int id) {
        Documentos documentos = null;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from documentos where id = ?");
            ps.setInt(1, id);

            ResultSet rs = ps.executeQuery();

            List<Documentos> documentosList = this.documentosFromResultSet(rs);
            if(documentosList.size() > 0){
                documentos = documentosList.get(0);
            }

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return documentos;
    }

    @Override
    public Documentos findByCaja(Caja caja) {
        Documentos documentos = null;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select * from documentos where caja_id = ?");
            ps.setInt(1, caja.getId());

            ResultSet rs = ps.executeQuery();

            List<Documentos> documentosList = this.documentosFromResultSet(rs);
            if(documentosList.size() > 0){
                documentos = documentosList.get(0);
            }

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return documentos;
    }

    @Override
    public boolean insertDocumentos(Documentos documentos) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("insert into documentos (cheques, tarjetas, retiros, caja_id) values (?,?,?,?)");
            ps.setInt(1, documentos.getCheques());
            ps.setInt(2, documentos.getTarjetas());
            ps.setInt(3, documentos.getRetiros());
            ps.setInt(4, documentos.getCaja().getId());

            updates = ps.executeUpdate();
            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            documentos.setId(rs.getInt(1));

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean insertDefaultDocumentos(Documentos documentos) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("insert into documentos (cheques, tarjetas, retiros, caja_id) values (0,0,0,?)");
            ps.setInt(1, documentos.getCaja().getId());

            updates = ps.executeUpdate();
            ps.close();

            ps = conn.prepareStatement("select last_insert_rowid()");
            ResultSet rs = ps.executeQuery();
            rs.next();
            documentos.setId(rs.getInt(1));

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean updateDocumentos(Documentos documentos) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("update documentos set tarjetas = ?, cheques = ?, retiros = ?, caja_id = ? where id = ?");
            ps.setInt(1, documentos.getTarjetas());
            ps.setInt(2, documentos.getCheques());
            ps.setInt(3, documentos.getRetiros());
            ps.setInt(4, documentos.getCaja().getId());
            ps.setInt(5, documentos.getId());
            updates = ps.executeUpdate();

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public boolean deleteDocumentos(Documentos documentos) {
        int updates;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("delete from documentos where id = ?");
            ps.setInt(1, documentos.getId());

            updates = ps.executeUpdate();

            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
            return false;
        }
        return updates > 0;
    }

    @Override
    public int getTotalDocumentos(Caja caja) {
        int total = 0;
        try {
            Connection conn = connectionHolder.getConnection();
            PreparedStatement ps = conn.prepareStatement("select cheques + tarjetas + retiros from documentos where caja_id = ?");
            ps.setInt(1, caja.getId());

            ResultSet rs = ps.executeQuery();
            rs.next();
            total = rs.getInt(1);

            rs.close();
            ps.close();
            conn.close();
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return total;
    }
}
